image: ubuntu:18.04

stages:
    - compile
    - pack

variables:
    DEFCONFIG_NAME: qt_toolchain_defconfig
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

compile:
    variables:
        GIT_SUBMODULE_STRATEGY: recursive
    stage: compile
    script:
        - apt-get update 
        - apt-get install -y make gcc file g++ patch wget cpio unzip rsync bc git python bzip2
        - mkdir -p /opt/qt_toolchain
        - cd buildroot
        - echo "Configure Buildroot for ${DEFCONFIG_NAME}"
        - make BR2_EXTERNAL=.. ${DEFCONFIG_NAME}
        - make
        - cd ..
        - tar -zcf qt_toolchain.tar.gz /opt/qt_toolchain
    artifacts:
        when: always
        expire_in: 1 weeks
        paths:
            - qt_toolchain.tar.gz
    tags:
        - docker-linux

pack:
    stage: pack    
    image: docker:19.03.8
    services:
        - docker:19.03.8-dind
    script:
        - tar -xzvf qt_toolchain.tar.gz
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker build -t $IMAGE_TAG .
        - docker push $IMAGE_TAG
    dependencies:
        - compile
